# typeface.py
# By Chris Proctor and _________

# Contains one function for each letter in the English alphabet. 
# Each function should draw its letter at a scale of `unit`, and then 
# return back to the same position and heading where it started. 

# Note: The `sqrt` function from math may be helpful--if you want to 
# move the turtle along the diagonal of a square with side length x, 
# the turtle should move a distance of sqrt(x)

from turtle import *
from math import sqrt
from math import atan
from math import degrees

def fly(distance):
    penup()
    forward(distance)
    pendown()

def draw_letter_a(unit):
    outer_angle = degrees(atan((3*unit)/(8*unit))) #defines outer angle turns in degrees
    inner_angle = degrees(atan((7*unit)/(3*unit))) #defines inner angle turns in degrees
    outer_side = unit*sqrt(73) #length of outer part of letter A
    inner_side = unit*sqrt(58) #length of inner part of letter A
    left(90-outer_angle)
    forward(outer_side)
    right(90-outer_angle)
    forward(unit*2)
    right(90-outer_angle)
    forward(outer_side)
    right(90+outer_angle)
    forward(unit)
    right(inner_angle)
    forward(.43*inner_side)
    left(inner_angle)
    forward(3.4*unit)
    penup()
    back(3.4*unit)
    right(inner_angle)
    forward(.14*(inner_side))
    pendown()
    left(inner_angle)
    forward(2.6*unit)
    penup()
    back(2.6*unit)
    right(inner_angle)
    pendown()
    forward(.43*(inner_side))
    left(2*inner_angle)
    forward(.43*(inner_side))
    penup()
    forward(.14*(inner_side))
    pendown()
    forward(.43*(inner_side))
    right(inner_angle)
    forward(unit)
    right(180)



    
    

def draw_letter_b(unit):
    pass

def draw_letter_c(unit):
    pass

    

def draw_letter_d(unit): #makes the arc part of the letter D for both outer and inner parts
  def d_arc(size_factor): #size_factor is the size of the arc part of the D
    forward(0.5*size_factor)
    circle(0.5*size_factor,180)
    forward(0.5*size_factor)
    left(90)
    forward(size_factor)
    
  d_arc(8*unit)
  left(90)
  fly(unit)
  left(90)
  fly(unit)
  right(90)
  d_arc(6*unit)
  fly(unit)
  right(90)
  fly(unit)
  right(180)


def draw_letter_e(unit):
    forward(8*unit)
    left(90)
    forward(1*unit)
    left(90)
    forward(7*unit)
    right(90)
    forward(2.5*unit)
    right(90)
    forward(7*unit)
    left(90)
    forward(1*unit)
    left(90)
    forward(7*unit)
    right(90)
    forward(2.5*unit)
    right(90)
    forward(7*unit)
    left(90)
    forward(1*unit)
    left(90)
    forward(8*unit)
    left(90)
    forward(8*unit)
    left(90)

def draw_letter_f(unit):
    pass

def draw_letter_g(unit):
    pass

def draw_letter_h(unit):
    pass

def draw_letter_i(unit):
    pass

def draw_letter_j(unit):
    pass

def draw_letter_k(unit):
    pass

def draw_letter_l(unit):
    pass

def draw_letter_m(unit):
    pass

def draw_letter_n(unit):
    pass

def draw_letter_o(unit):
    pass

def draw_letter_p(unit):
    pass

def draw_letter_q(unit):
    pass

def draw_letter_r(unit):
    pass

def draw_letter_s(unit):
    pass

def draw_letter_t(unit):
    pass

def draw_letter_u(unit):
    pass

def draw_letter_v(unit):
    pass

def draw_letter_w(unit):
    pass

def draw_letter_x(unit):
    
    def half_x():
        left(45)
        forward((3/7)*sqrt(98)*unit)
        fly(sqrt(2)*unit)
        forward((3/7)*sqrt(98)*unit)
        left(90)
        forward(sqrt(2)*unit)
        left(90)
        forward((3/7)*sqrt(98)*unit)
        fly(sqrt(2)*unit)
        forward((3/7)*sqrt(98)*unit)
        left(90)
        forward(sqrt(2)*unit)
       
    fly(unit)
    half_x()
    left(45)
    fly(unit*7)
    left(90)
    fly(unit)
    half_x()
    right(135)
    fly(unit)
    right(90)
    fly(8*unit)
    right(180)





def draw_letter_y(unit):
    pass

def draw_letter_z(unit):
    pass
